#!/bin/sh
# $Id: sonic-pi.SlackBuild,v 1.9 2025/01/11 22:17:14 root Exp root $
# Copyright 2020, 2021, 2022, 2023, 2025  Eric Hameleers, Eindhoven, NL
# All rights reserved.
#
#   Permission to use, copy, modify, and distribute this software for
#   any purpose with or without fee is hereby granted, provided that
#   the above copyright notice and this permission notice appear in all
#   copies.
#
#   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
#   WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#   IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script 
# ===========================
# By:          Eric Hameleers <alien@slackware.com>
# For:         sonic-pi
# Descr:       live coding music performance tool
# URL:         https://sonic-pi.net/
# Build needs: elixir erlang-otp
# Needs:       aubio jack2 jack-example-tools sc3-plugins supercollider
# Changelog:   
# 3.2.2-1:     21/Jul/2020 by Eric Hameleers <alien@slackware.com>
#              * Initial build.
# 3.2.2-2:     10/oct/2020 by Eric Hameleers <alien@slackware.com>
#              * Add 'X-DAW' category to the desktop file (for liveslak).
# 3.3.1-1:     11/mar/2021 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 4.1.0-1:     30/aug/2022 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 4.3.0-1:     18/jun/2023 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 4.5.1-1:     11/jan/2025 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 
# Run 'sh sonic-pi.SlackBuild' to build a Slackware package.
# The package (.t?z) and .txt file as well as build logs are created in /tmp .
# Install the package using 'installpkg' or 'upgradepkg --install-new'.
#
# -----------------------------------------------------------------------------

PRGNAM=sonic-pi
VERSION=${VERSION:-4.5.1}
BUILD=${BUILD:-1}
NUMJOBS=${NUMJOBS:-" -j$(nproc) "}
TAG=${TAG:-alien}

DOCS="*.md CORETEAM.html FUNDING.yml appveyor.yml"

# Found in app/linux-pre-vcpkg.sh:
VCPKG_BRANCH=${VCPKG_BRANCH:-2023.11.20}

# Where do we look for sources?
SRCDIR=$(cd $(dirname $0); pwd)

# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

SOURCE="$SRCDIR/${PRGNAM}-${VERSION}.tar.gz"
SRCURL="https://github.com/samaaron/${PRGNAM}/archive/v${VERSION}.tar.gz"

##
## --- with a little luck, you won't have to edit below this point --- ##
##

# Automatically determine the architecture we're building on:
if [ -z "$ARCH" ]; then
  case "$(uname -m)" in
    i?86) ARCH=i586 ;;
    arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
    # Unless $ARCH is already set, use uname -m for all other archs:
    *) ARCH=$(uname -m) ;;
  esac
  export ARCH
fi
# Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
case "$ARCH" in
  i?86)      SLKCFLAGS="-O0 -march=${ARCH} -mtune=i686"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  x86_64)    SLKCFLAGS="-O2 -fPIC"
             SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
             ;;
  armv7hl)   SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  *)         SLKCFLAGS=${SLKCFLAGS:-"-O2"}
             SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
             ;;
esac

case "$ARCH" in
    arm*)    TARGET=$ARCH-slackware-linux-gnueabi ;;
    *)       TARGET=$ARCH-slackware-linux ;;
esac

# Exit the script on errors:
set -e
trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}

# Save old umask and set to 0022:
_UMASK_=$(umask)
umask 0022

# Create working directories:
mkdir -p $OUTPUT          # place for the package to be saved
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
mkdir -p $PKG             # place for the package to be built
rm -rf $PKG/*             # always erase old package's contents
rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
rm -rf $OUTPUT/{checkout,configure,make,install,error,makepkg,patch}-$PRGNAM.log
                          # remove old log files

# Source file availability:
if ! [ -f ${SOURCE} ]; then
  echo "Source '$(basename ${SOURCE})' not available yet..."
  # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
  [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
  if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
  if ! [ "x${SRCURL}" == "x" ]; then
    echo "Will download file to $(dirname $SOURCE)"
    wget --no-check-certificate -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
    if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
      echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
      mv -f "${SOURCE}" "${SOURCE}".FAIL
      exit 1
    fi
  else
    echo "File '$(basename ${SOURCE})' not available... aborting the build."
    exit 1
  fi
fi

if [ "$P1" == "--download" ]; then
  echo "Download complete."
  exit 0
fi

# --- PACKAGE BUILDING ---

echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"

cd $TMP/tmp-$PRGNAM
echo "Extracting the source archive(s) for $PRGNAM..."
tar -xf ${SOURCE}
cd ${PRGNAM}-${VERSION}
PIROOT=$(pwd)
APPROOT=${PIROOT}/app

chown -R root:root .
chmod -R u+w,go+r-w,a+rX-st .

echo Building ...
export LDFLAGS="$SLKLDFLAGS"
export CXXFLAGS="$SLKCFLAGS"
export CFLAGS="$SLKCFLAGS"

# Mostly do what these embedded scripts do:
# app/linux-pre-vcpkg.sh
# app/linux-prebuild.sh
# app/linux-pre-translations.sh
# app/linux-config.sh
# app/linux-build-gui.sh
# app/linux-post-tau-prod-release.sh
# app/linux-release.sh

# Compile vspkg and use it to compile several internal dependent libraries:
mkdir -p ${APPROOT}/vcpkg
cd ${APPROOT}/vcpkg
  git clone --depth 1 --branch ${VCPKG_BRANCH} \
    https://github.com/microsoft/vcpkg.git .
  if [ "$ARCH" = "i586" ]; then
    # Add the 'x86-linux' architecture which vcpkg does not know:
    sed -i scripts/buildsystems/vcpkg.cmake \
        -e '/^ *elseif(CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "s390x")/ielseif(CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "i686")\nset(Z_VCPKG_TARGET_TRIPLET_ARCH x86)'
    mkdir custom-triplets
    cat triplets/x64-linux.cmake | sed -e 's/x64/x86/' \
      > custom-triplets/x86-linux.cmake
    VCARGS=" --overlay-triplets=custom-triplets "
  else
    VCARGS=" "
  fi
  ./bootstrap-vcpkg.sh -disableMetrics
  ./vcpkg ${VCARGS} install \
    libsndfile[core,external-libs] kissfft fmt crossguid sdl2[x11] gl3w \
    reproc gsl-lite concurrentqueue platform-folders catch2 \
    --recurse
cd - 1>/dev/null

# Compile native ruby extensions:
ruby ${APPROOT}/server/ruby/bin/compile-extensions.rb

# Translate the tutorial:
ruby ${APPROOT}/server/ruby/bin/i18n-tool.rb -t

# Generate docs for the Qt GUI:
cp ${APPROOT}/gui/qt/utils/ruby_help.tmpl ${APPROOT}/gui/qt/utils/ruby_help.h
ruby ${APPROOT}/server/ruby/bin/qt-doc.rb -o ${APPROOT}/gui/qt/utils/ruby_help.h

# Compile the GUI:
mkdir ${APPROOT}/build
cd ${APPROOT}/build
  cmake -G "Unix Makefiles" \
    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
    -DCMAKE_BUILD_TYPE=Release \
    -DBUILD_IMGUI_INTERFACE=false \
    -DUSE_SYSTEM_LIBS=false \
    ..
  cmake --build . --config Release
cd - 1>/dev/null

# Compile Erlang/Elixir files:
mix local.hex --force
cd ${APPROOT}/server/beam/tau
  # Compiling fails, so we will download the deps instead:
  #MIX_ENV=prod mix deps.compile
  #MIX_ENV=prod mix release --overwrite --no-deps-check
  MIX_ENV=prod mix local.hex --force
  MIX_ENV=prod mix local.rebar --force
  MIX_ENV=prod mix deps.get
  MIX_ENV=prod mix release --overwrite
cd - 1>/dev/null

# Install the lot into the package dir.
# Use standard locations, and apply symlinks to tie it all together.
# Create directories:
cd ${PIROOT}
mkdir -p ${PKG}/usr/libexec/sonic-pi

# Copy distributable files:
cp -r ${PIROOT}/{bin,etc} ${PKG}/usr/libexec/sonic-pi/

# Copy example configs:
mkdir -p ${PKG}/usr/libexec/sonic-pi/app
cp -r ${APPROOT}/config ${PKG}/usr/libexec/sonic-pi/app/

# Copy server natives:
mkdir -p ${PKG}/usr/libexec/sonic-pi/app/server
cp -r ${APPROOT}/server/native ${PKG}/usr/libexec/sonic-pi/app/server/

# Copy Spider (Ruby) server:
mkdir -p ${PKG}/usr/libexec/sonic-pi/app/server
cp -r ${APPROOT}/server/ruby ${PKG}/usr/libexec/sonic-pi/app/server/

# Copy built Tau (BEAM) server:
mkdir -p ${PKG}/usr/libexec/sonic-pi/app/server/beam/tau/_build/prod
cp -r ${APPROOT}/server/beam/tau/_build/prod/rel \
  ${PKG}/usr/libexec/sonic-pi/app/server/beam/tau/_build/prod/
cp ${APPROOT}/server/beam/tau/boot-lin.sh \
  ${PKG}/usr/libexec/sonic-pi/app/server/beam/tau/

# Copy only necessary files for the Qt GUI:
mkdir -p ${PKG}/usr/libexec/sonic-pi/app/gui/qt
cp -r ${APPROOT}/gui/qt/{lang,theme} \
  ${PKG}/usr/libexec/sonic-pi/app/gui/qt/

# Copy Qt GUI binary:
mkdir -p ${PKG}/usr/libexec/sonic-pi/app/build/gui/qt
cp ${APPROOT}/build/gui/qt/sonic-pi \
  ${PKG}/usr/libexec/sonic-pi/app/build/gui/qt/sonic-pi

if [ -x ${APPROOT}/build/gui/imgui/sonic-pi-imgui ]; then
  # Copy ImGui files:
  mkdir -p ${PKG}/usr/libexec/sonic-pi/app/gui/imgui/res
  cp -r ${APPROOT}/gui/imgui/res/Cousine-Regular.ttf \
    ${PKG}/usr/libexec/sonic-pi/app/gui/imgui/res/

  # Copy ImGui binary:
  mkdir -p ${PKG}/usr/libexec/sonic-pi/app/build/gui/imgui
  cp ${APPROOT}/build/gui/imgui/sonic-pi-imgui \
    ${PKG}/usr/libexec/sonic-pi/app/build/gui/imgui/sonic-pi-imgui
fi

# Remove non-essential files from vendored Ruby gems:
for file in ${PKG}/usr/libexec/sonic-pi/app/server/ruby/vendor/*/*; do
  if [ "$(basename "$file")" != "lib" ]; then
    rm -rf "$file"
  fi
done

# Remove unnecessary Erlang artifacts:
rm ${PKG}/usr/libexec/sonic-pi/app/server/beam/tau/_build/prod/rel/tau/bin/tau.bat

# Strip Erlang BEAMs:
erl -noinput -eval \
  'lists:foreach(fun(F) -> beam_lib:strip(F) end, filelib:wildcard("build/linux_dist/app/server/beam/tau/**/*.beam"))' \
  -s init stop

# The documentation:
# For the GUI:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION/gui
cp -a ${APPROOT}/gui/qt/book $PKG/usr/doc/$PRGNAM-$VERSION/gui/
ln -s /usr/doc/$PRGNAM-$VERSION/gui/book  $PKG/usr/libexec/sonic-pi/app/gui/qt/
cp -a ${APPROOT}/gui/qt/help $PKG/usr/doc/$PRGNAM-$VERSION/gui/
ln -s /usr/doc/$PRGNAM-$VERSION/gui/help  $PKG/usr/libexec/sonic-pi/app/gui/qt/
cp -a ${APPROOT}/gui/qt/html $PKG/usr/doc/$PRGNAM-$VERSION/gui/
ln -s /usr/doc/$PRGNAM-$VERSION/gui/html  $PKG/usr/libexec/sonic-pi/app/gui/qt/
mv $PKG/usr/libexec/sonic-pi/etc/doc/* $PKG/usr/doc/$PRGNAM-$VERSION/
rmdir $PKG/usr/libexec/sonic-pi/etc/doc
ln -s /usr/doc/$PRGNAM-$VERSION  $PKG/usr/libexec/sonic-pi/etc/doc
# For the synthdefs:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION/synthdefs
mv $PKG/usr/libexec/sonic-pi/etc/synthdefs/graphviz/{dot,pdf} $PKG/usr/doc/$PRGNAM-$VERSION/synthdefs/
ln -s /usr/doc/$PRGNAM-$VERSION/synthdefs/dot $PKG/usr/libexec/sonic-pi/etc/synthdefs/graphviz/
ln -s /usr/doc/$PRGNAM-$VERSION/synthdefs/pdf $PKG/usr/libexec/sonic-pi/etc/synthdefs/graphviz/
# Also move the examples into the docdir:
mv $PKG/usr/libexec/sonic-pi/etc/examples $PKG/usr/doc/$PRGNAM-$VERSION/
ln -s /usr/doc/$PRGNAM-$VERSION/examples $PKG/usr/libexec/sonic-pi/etc/

# Create a program wrapper:
mkdir -p $PKG/usr/bin
cat <<EOT > $PKG/usr/bin/sonic-pi
#!/bin/sh
cd /usr/libexec/sonic-pi
./bin/sonic-pi
EOT
chmod 755 $PKG/usr/bin/sonic-pi

# Install a desktop file:
mkdir -p $PKG/usr/share/pixmaps
cp -a ${APPROOT}/gui/qt/images/icon-smaller.png \
  $PKG/usr/share/pixmaps/sonic-pi.png
mkdir -p $PKG/usr/share/applications
cat <<EOT > $PKG/usr/share/applications/$PRGNAM.desktop
[Desktop Entry]
Name=Sonic Pi
Comment=Live Coding Music Synth
Exec=sonic-pi
Terminal=false
Type=Application
Categories=X-DAW;Application;AudioVideo;Audio;
Icon=sonic-pi
EOT

# Add this to the doinst.sh:
mkdir -p $PKG/install
cat <<EOINS >> $PKG/install/doinst.sh
# Update the desktop database:
if [ -x usr/bin/update-desktop-database ]; then
  chroot . /usr/bin/update-desktop-database usr/share/applications > /dev/null 2>&1
fi

# Update hicolor theme cache:
if [ -d usr/share/icons/hicolor ]; then
  if [ -x /usr/bin/gtk-update-icon-cache ]; then
    chroot . /usr/bin/gtk-update-icon-cache -f -t usr/share/icons/hicolor 1> /dev/null 2> /dev/null
  fi
fi

# Update the mime database:
if [ -x usr/bin/update-mime-database ]; then
  chroot . /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
fi

EOINS

# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
find $PKG/usr/doc -type f -exec chmod 644 {} \;

# Compress the man page(s):
if [ -d $PKG/usr/man ]; then
  find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
  for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
fi

# Strip binaries (if any):
find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
  | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true

# Add a package description:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc
cat $SRCDIR/slack-required > $PKG/install/slack-required

# Build the package:
cd $PKG
makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
cd $OUTPUT
md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz}.md5
cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep

# Restore the original umask:
umask ${_UMASK_}

